;############ Getting Dimensions and # of Bands of an image-file    ############
FUNCTION get_width_c, filename
   RETURN, CALL_EXTERNAL(dylib_path() , 'get_width_c',filename,VALUE=[1],/CDECL, /AUTO_GLUE)
END

FUNCTION get_height_c, filename
   RETURN, CALL_EXTERNAL(dylib_path() , 'get_height_c',filename,VALUE=[1],/CDECL, /AUTO_GLUE)
END

FUNCTION get_numBands_c, filename
   RETURN, CALL_EXTERNAL(dylib_path() , 'get_numBands_c',filename,VALUE=[1],/CDECL, /AUTO_GLUE)
END

;###############################################################################
;###################             Loading images             ####################
FUNCTION vigra_importimage_c, array, width, height, filename
	RETURN, CALL_EXTERNAL(dylib_path() , 'vigra_importimage_c', array, width, height, filename, $
							VALUE=[0,1,1,1],/CDECL, /AUTO_GLUE)
END

FUNCTION loadimage, filename
	width  = get_width_c(filename)
    height = get_height_c(filename)
	IF  width EQ 0 OR height EQ 0 THEN BEGIN
		MESSAGE, "Error in vigraidl.impex.loadimage: Image not found"
	ENDIF ELSE BEGIN
     	array = MAKE_ARRAY(width, height, /FLOAT, VALUE = 0.0)
      err = vigra_importimage_c(array, width, height, filename)
    	CASE err OF
    		0: 	RETURN, array
    		1:	MESSAGE, "Error in vigraplt.impex.loadimage: Image cannot be loaded by vigra!"
    		2: 	MESSAGE, "Error in vigraplt.impex.loadimage: Image is not grayscale!"
	    	3:	MESSAGE, "Error in vigraplt.impex.loadimage: Sizes do not match!"
	    ENDCASE
	ENDELSE
END


;###############################################################################
;###################             Saving images              ####################
FUNCTION vigra_exportimage_c, array, width, height, filename
	RETURN, CALL_EXTERNAL(dylib_path() , 'vigra_exportimage_c', array, width, height, filename, $
							VALUE=[0,1,1,1],/CDECL, /AUTO_GLUE)
END

FUNCTION saveimage, array, filename
  shape = SIZE(array)
	err = vigra_exportimage_c(array, shape[1], shape[2], filename)
    CASE err OF
    	0: 	RETURN,1
    	1:	MESSAGE, "Error in vigraplt.impex.saveimage: Image cannot be saved by vigra!"
	ENDCASE
END