;###############################################################################
;###################         Erode image                   ####################
FUNCTION vigra_discerosion_c, array, array2, width, height, radius
  RETURN, CALL_EXTERNAL(dylib_path() , 'vigra_discerosion_c', array, array2, FIX(width), FIX(height), FIX(radius), $
              VALUE=[0,0,1,1,1],/CDECL, /AUTO_GLUE)
END

FUNCTION erodeimage, array, radius
  shape = SIZE(array)
  array2 = MAKE_ARRAY(shape[1], shape[2], /FLOAT, VALUE = 0.0)
  err = vigra_discerosion_c(array, array2, shape[1], shape[2], radius)
  CASE err OF
    0: RETURN, array2
    1: MESSAGE, "Error in vigraidl.morphology:erodeimage: Erosion of image failed!!"
  ENDCASE
END

;###############################################################################
;###################         Dilate image                   ####################
FUNCTION vigra_discdilation_c, array, array2, width, height, radius
  RETURN, CALL_EXTERNAL(dylib_path() , 'vigra_discdilation_c', array, array2, FIX(width), FIX(height), FIX(radius), $
              VALUE=[0,0,1,1,1],/CDECL, /AUTO_GLUE)
END

FUNCTION dilateimage, array, radius
  shape = SIZE(array)
  array2 = MAKE_ARRAY(shape[1], shape[2], /FLOAT, VALUE = 0.0)
  err = vigra_discdilation_c(array, array2, shape[1], shape[2], radius)
  CASE err OF
    0: RETURN, array2
    1: MESSAGE, "Error in vigraidl.morphology:dilateimage: Dilation of image failed!!"
  ENDCASE
END

;###############################################################################
;###################         Opening  image                 ####################

FUNCTION openingimage, array, radius
  RETURN, dilateimage(erodeimage(array, radius), radius)
END


;###############################################################################
;###################         Closing image                  ####################

FUNCTION closingimage, array, radius
  RETURN, erodeimage(dilateimage(array, radius), radius)
END